%define module_name	alsa
%define module_version	0.9.8
%define module_release	alt4.2

%define kversion	2.4.22
%define krelease	alt2
%define flavour		wks-up

%define base_arch %(echo %_target_cpu | sed 's/i.86/i386/;s/athlon/i386/')

%define kgcc		gcc-2.96
%define kgcc_package	gcc2.96

%ifdef use_ccache
%define kcc "ccache %kgcc"
%else
%define kcc "%kgcc"
%endif

%define module_dir /lib/modules/%kversion-%flavour-%krelease/%module_name

Summary: The Advanced Linux Sound Architecture modules
Name: kernel-modules-%module_name-%flavour
Version: %module_version
Release: %module_release
License: GPL
Group: System/Kernel and hardware

Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>

Provides: alsa = %version

Patch1:  01-via82xx-capture.patch
Patch2:  02-resume-oops.patch
Patch3:  03-ac97-it2646.patch
Patch4:  04-cs46xx-4channel.patch
Patch5:  05-ad1848-spinlock-fix.patch
Patch6:  06-pnp-detect-fix.patch
Patch7:  07-opti92x-ad1848-pnp.patch
Patch8:  08-ac97-ad198x.patch
Patch9:  09-via82xx-asus-a7v600.patch
Patch10: 10-emu10k1-update.patch
Patch11: 11-ac97-ic-ensemble.patch
Patch12: 12-i2c-sleep.patch
Patch13: 13-gus-duplicate-control.patch
Patch90: 90-alsa-driver-0.9.8-intel8x0-blacklist.patch
Patch91: 91_via82xx-whitelist.patch

ExclusiveOS: Linux
Url: http://www.kernel.org/
BuildPreReq:    kernel-build-tools
BuildRequires: %kgcc_package
BuildRequires: modutils
BuildRequires: perl
BuildRequires: rpm >= 4.0.2-75
BuildRequires: kernel-headers-%flavour = %kversion-%krelease
BuildRequires: kernel-source-alsa-%module_version

Provides:  kernel-modules-%module_name-%kversion-%flavour-%krelease = %version-%release
Conflicts: kernel-modules-%module_name-%kversion-%flavour-%krelease < %version-%release
Conflicts: kernel-modules-%module_name-%kversion-%flavour-%krelease > %version-%release

PreReq: coreutils
PreReq: modutils
PreReq: kernel-image-%flavour = %kversion-%krelease
Requires(postun): kernel-image-%flavour = %kversion-%krelease
ExclusiveArch: %ix86

%description
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features:
1. Efficient support for all types of audio interfaces, from consumer
soundcards to professional multichannel audio interfaces.
2. Fully modularized sound drivers.
3. SMP and thread-safe design.
4. User space library (alsa-lib) to simplify application programming
and provide higher level functionality.
5. Support for the older OSS API, providing binary compatibility for
most OSS programs.

These are sound drivers for your ALT Linux system.

%prep
rm -rf kernel-source-%module_name-%module_version

tar -jxvf %kernel_src/kernel-source-%module_name-%module_version.tar.bz2

%setup -D -T -n kernel-source-%module_name-%module_version

# workaround for different layout in CVS and tarball - makes applying
# patches from CVS easier
%__ln_s . alsa-driver

%patch1  -p0
%patch2  -p0
%patch3  -p0
%patch4  -p0
%patch5  -p0
%patch6  -p0
%patch7  -p0
%patch8  -p0
%patch9  -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch90 -p1
%patch91 -p1

%build
CC=%kcc ./configure --with-kernel=%_includedir/linux-%kversion-%flavour/ \
    --with-isapnp=yes --with-sequencer=yes \
    --with-moddir=%module_dir
%make_build CC=%kcc

%install
mkdir -p \
    $RPM_BUILD_ROOT/%module_dir
mkdir -p \
    $RPM_BUILD_ROOT/%_includedir/sound
make install-modules DESTDIR=$RPM_BUILD_ROOT \
    IGROUP=`id -g` IUSER=`id -u`

%post
/sbin/depmod -a -F /boot/System.map-%kversion-%flavour-%krelease \
    %kversion-%flavour-%krelease

%postun
[ ! -f /boot/System.map-%kversion-%flavour-%krelease ] || \
/sbin/depmod -a -F /boot/System.map-%kversion-%flavour-%krelease \
    %kversion-%flavour-%krelease

%files
%module_dir

%changelog
* Fri Nov 28 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.8-alt4.2
- Added Provides/Conflicts to make sure that only one version of the package
  can be installed for each kernel version.
- Added patches:
  + 91_via82xx-whitelist.patch: added ASUS A7V8X on-board sound chip to the
    whitelist in snd-via82xx (DXS channels are working properly).

* Mon Nov 17 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.8-alt3.2
- Fixed spec file name.
- Changed %%module_dir to avoid overlap with other packages.
- Avoid %%postun failure when this package is removed after
  kernel-image-%%flavour (currently rpm cannot prevent this).
- Added patches from CVS:
  + 01-via82xx-capture.patch:
    - snd-via82xx: fixed the calculation of the port for "Capture Source"
      control switch
  + 02-resume-oops.patch:
    - fixed oops at resume
    - block also the non-blocking devices until the resume is finished
  + 03-ac97-it2646.patch:
    - added patch for IT2646 AC97 codec
  + 04-cs46xx-4channel.patch:
    - fixed the 4channel mode of another CS429x codec (0x592b)
  + 05-ad1848-spinlock-fix.patch:
    - ad1848: Fixed spinlocks
  + 06-pnp-detect-fix.patch:
    - fixed the double detection of the card
    - the lock-up problem of some cs4232 boards should be fixed
  + 07-opti92x-ad1848-pnp.patch:
    - fixed the detection of opti92x-ad1848 pnp
    - added EXPORT_NO_SYMBOLS (snd-opti92x-cs4231, snd-opti93x)
  + 08-ac97-ad198x.patch:
    - new controls for AD1981A/B/1980/1985
  + 09-via82xx-asus-a7v600.patch:
    - added the quirk for ASUS A7V600
  + 10-emu10k1-update.patch:
    - disable routing from AC97 line out to front speakers
    - AC97 ADC is used only for Mic playback and recording
    - Philips ADC is used for other analog playback and recording (Analog Mix
      Playback Volume, Analog Mix Capture Volume)
    - removes unused AC97 controls (is phone used ???)
    - removed the duplicated IEC958 control on Dell's board
  + 11-ac97-ic-ensemble.patch:
    - Added IC Ensemble/KS Waves ID for stereo enhancement
  + 12-i2c-sleep.patch:
    - fixed sleep in lock.  use mutex for the locking
  + 13-gus-duplicate-control.patch:
    - Fixed duplicate control IDs (PCM Playback Volume) for cards with
      the codec chip

* Wed Nov 05 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.8-alt2.2
- Added Intel D845GRG to blacklist (mixer uses Headphones instead of Master).

* Thu Oct 23 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.8-alt1.2
- 0.9.8

* Mon Oct 13 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.7-alt3.2
- 0.9.7c
- Removed Patch1 (fixed upstream)

* Sun Oct 12 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.7-alt2.2
- 0.9.7b
- Patch1: fixed SMP build

* Fri Sep 26 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.7-alt1.2
- 0.9.7
- replaced %%{_usrsrc}/kernel/sources with %%kernel_src

* Wed Sep 03 2003 Rider <rider@altlinux.ru> 0.9.6-alt9.2
- replace /usr/include to %_includedir
- added build requires

* Tue Aug 26 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt8
- rebuilt with 2.4.21rel-alt14

* Fri Aug 15 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt7
- rebuilt with 2.4.21rel-alt13

* Wed Aug 13 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt6
- rebuilt with 2.4.21rel-alt12

* Tue Aug 12 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt5
- rebuilt with 2.4.21rel-alt11

* Mon Aug 11 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt4
- rebuilt with 2.4.21rel-alt10

* Thu Aug 07 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt3
- rebuilt with 2.4.21rel-alt9

* Wed Aug 06 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt2
- rebuilt with 2.4.21rel-alt8

* Wed Jul 30 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt1
- 2.9.6
- built with 2.4.21rel-alt7

* Tue Jul 29 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.5-alt4
- headers package is now generated from -source package.

* Thu Jul 17 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.5-alt3
- rebuilt with 2.4.21rel-alt6

* Wed Jul 16 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.5-alt2
- rebuilt with 2.4.21rel alt5

* Tue Jul 15 2003 Michael Shigorin <mike@altlinux.ru> 0.9.5-alt1
- 0.9.5
- removed kernel-headers-i2c from requires since they seem to be
  rolled into common kernel-headers

* Mon Jul 14 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.4-alt5
- rebuilt with 2.4.21rel alt4

* Tue Jul 08 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.4-alt4
- rebuilt with 2.4.21rel alt3
- removed i2c dependancies

* Tue Jul 08 2003 Michael Shigorin <mike@altlinux.ru> 0.9.4-alt3
- added Provides: alsa-driver-headers = %%kversion-%%krelease
  and supposedly fixed for BuildRequires:  %%kgcc_package
  so that it is backwards compatible with older build deps,
  side compatible with another alsa header packages and generally
  buildable within BTE
- fixed macro expansion in changelog
- fixed typo in 0.9.4-alt1 changelog entry
- cleaned up unneeded %%defattr's
- run cleanup_spec
- run buildreq, just in case => everything already in place

* Wed Jul 02 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.4-alt2
- added Provides: alsa = %%version

* Sat Jun 21 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.4-alt1
- rebuilt with 2.4.21rel
- 0.9.4 release.

* Tue May 20 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.2-alt4
- Rebuilt with 2.4.21rc1-alt2

* Mon Apr 3 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.2-alt3
- Added description and summary

* Mon Mar 31 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.2-alt2
- Moved headers to /usr/src/linux-%%{kversion}-%%{flavour}/include/sound

* Thu Mar 20 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.2-alt1
- New upstream version.

* Wed Mar 19 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.1-alt2
- Rebuilt with vanilla 2.4.21pre5-alt0.2 kernel

* Wed Feb 19 2003 Peter Novodvorsky <nidd@altlinux.org> 2.4.20-alt0.1
- initial release of NGKPs
